#include <iostream>

using namespace std;

int main()
{
    int N;
    long long br=0,bz=1,bi=0;
    cin>>N;
    long long X[N], Y[N], Z[N];
    for(int i=1; i<=N; i++)
        cin>>X[i];
    for(int j=1; j<=N; j++)
        cin>>Y[j];
    cin>>Z[1];
    if(Z[1]==1)bi++;
    for(int k=2; k<=N; k++)
        {cin>>Z[k];if(Z[k]==Z[k-1]){bz++;}if(Z[k]==k){bi++;}}
    if(bi==N)
    {
        for(int i=1; i<=N; i++)
    {
        for(int j=1; j<=N; j++)
        {
            if(X[i]==Y[j])
                {
                    if(j<=N)
                        br++;
                }
        }
    }
    }
    if(bz==N)
    {
        for(int i=1; i<=N; i++)
    {
        for(int j=1; j<=N; j++)
        {
            if(X[i]==Y[j])
                {
                    if(Z[1]==j)
                        br++;
                }
        }
    }
    }
    else
    {
      for(int i=1; i<=N; i++)
    {
        for(int j=1; j<=N; j++)
        {
            if(X[i]==Y[j])
                for(int k=1; k<=N; k++)
                {
                    if(Z[k]==j)
                        br++;
                }
        }
    }
    }

    cout<<br;
    return 0;
}